<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Source to the Rust file `/home/keir/.cargo/registry/src/github.com-1ecc6299db9ec823/rand-0.7.3/src/rngs/thread.rs`."><meta name="keywords" content="rust, rustlang, rust-lang"><title>thread.rs.html -- source</title><link rel="stylesheet" type="text/css" href="../../../normalize.css"><link rel="stylesheet" type="text/css" href="../../../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../../../dark.css"><link rel="stylesheet" type="text/css" href="../../../light.css" id="themeStyle"><script src="../../../storage.js"></script><noscript><link rel="stylesheet" href="../../../noscript.css"></noscript><link rel="shortcut icon" href="https://www.rust-lang.org/favicon.ico"><style type="text/css">#crate-search{background-image:url("../../../down-arrow.svg");}</style></head><body class="rustdoc source"><!--[if lte IE 8]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="sidebar"><div class="sidebar-menu">&#9776;</div><a href='../../../rand/index.html'><div class='logo-container'><img src='https://www.rust-lang.org/logos/rust-logo-128x128-blk.png' alt='logo'></div></a></nav><div class="theme-picker"><button id="theme-picker" aria-label="Pick another theme!"><img src="../../../brush.svg" width="18" alt="Pick another theme!"></button><div id="theme-choices"></div></div><script src="../../../theme.js"></script><nav class="sub"><form class="search-form"><div class="search-container"><div><select id="crate-search"><option value="All crates">All crates</option></select><input class="search-input" name="search" disabled autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"></div><a id="settings-menu" href="../../../settings.html"><img src="../../../wheel.svg" width="18" alt="Change settings"></a></div></form></nav><section id="main" class="content"><pre class="line-numbers"><span id="1">  1</span>
<span id="2">  2</span>
<span id="3">  3</span>
<span id="4">  4</span>
<span id="5">  5</span>
<span id="6">  6</span>
<span id="7">  7</span>
<span id="8">  8</span>
<span id="9">  9</span>
<span id="10"> 10</span>
<span id="11"> 11</span>
<span id="12"> 12</span>
<span id="13"> 13</span>
<span id="14"> 14</span>
<span id="15"> 15</span>
<span id="16"> 16</span>
<span id="17"> 17</span>
<span id="18"> 18</span>
<span id="19"> 19</span>
<span id="20"> 20</span>
<span id="21"> 21</span>
<span id="22"> 22</span>
<span id="23"> 23</span>
<span id="24"> 24</span>
<span id="25"> 25</span>
<span id="26"> 26</span>
<span id="27"> 27</span>
<span id="28"> 28</span>
<span id="29"> 29</span>
<span id="30"> 30</span>
<span id="31"> 31</span>
<span id="32"> 32</span>
<span id="33"> 33</span>
<span id="34"> 34</span>
<span id="35"> 35</span>
<span id="36"> 36</span>
<span id="37"> 37</span>
<span id="38"> 38</span>
<span id="39"> 39</span>
<span id="40"> 40</span>
<span id="41"> 41</span>
<span id="42"> 42</span>
<span id="43"> 43</span>
<span id="44"> 44</span>
<span id="45"> 45</span>
<span id="46"> 46</span>
<span id="47"> 47</span>
<span id="48"> 48</span>
<span id="49"> 49</span>
<span id="50"> 50</span>
<span id="51"> 51</span>
<span id="52"> 52</span>
<span id="53"> 53</span>
<span id="54"> 54</span>
<span id="55"> 55</span>
<span id="56"> 56</span>
<span id="57"> 57</span>
<span id="58"> 58</span>
<span id="59"> 59</span>
<span id="60"> 60</span>
<span id="61"> 61</span>
<span id="62"> 62</span>
<span id="63"> 63</span>
<span id="64"> 64</span>
<span id="65"> 65</span>
<span id="66"> 66</span>
<span id="67"> 67</span>
<span id="68"> 68</span>
<span id="69"> 69</span>
<span id="70"> 70</span>
<span id="71"> 71</span>
<span id="72"> 72</span>
<span id="73"> 73</span>
<span id="74"> 74</span>
<span id="75"> 75</span>
<span id="76"> 76</span>
<span id="77"> 77</span>
<span id="78"> 78</span>
<span id="79"> 79</span>
<span id="80"> 80</span>
<span id="81"> 81</span>
<span id="82"> 82</span>
<span id="83"> 83</span>
<span id="84"> 84</span>
<span id="85"> 85</span>
<span id="86"> 86</span>
<span id="87"> 87</span>
<span id="88"> 88</span>
<span id="89"> 89</span>
<span id="90"> 90</span>
<span id="91"> 91</span>
<span id="92"> 92</span>
<span id="93"> 93</span>
<span id="94"> 94</span>
<span id="95"> 95</span>
<span id="96"> 96</span>
<span id="97"> 97</span>
<span id="98"> 98</span>
<span id="99"> 99</span>
<span id="100">100</span>
<span id="101">101</span>
<span id="102">102</span>
<span id="103">103</span>
<span id="104">104</span>
<span id="105">105</span>
<span id="106">106</span>
<span id="107">107</span>
<span id="108">108</span>
<span id="109">109</span>
<span id="110">110</span>
<span id="111">111</span>
<span id="112">112</span>
<span id="113">113</span>
<span id="114">114</span>
<span id="115">115</span>
<span id="116">116</span>
<span id="117">117</span>
<span id="118">118</span>
<span id="119">119</span>
<span id="120">120</span>
<span id="121">121</span>
<span id="122">122</span>
<span id="123">123</span>
<span id="124">124</span>
</pre><div class="example-wrap"><pre class="rust ">
<span class="comment">// Copyright 2018 Developers of the Rand project.</span>
<span class="comment">//</span>
<span class="comment">// Licensed under the Apache License, Version 2.0 &lt;LICENSE-APACHE or</span>
<span class="comment">// https://www.apache.org/licenses/LICENSE-2.0&gt; or the MIT license</span>
<span class="comment">// &lt;LICENSE-MIT or https://opensource.org/licenses/MIT&gt;, at your</span>
<span class="comment">// option. This file may not be copied, modified, or distributed</span>
<span class="comment">// except according to those terms.</span>

<span class="doccomment">//! Thread-local random number generator</span>

<span class="kw">use</span> <span class="ident">std</span>::<span class="ident">cell</span>::<span class="ident">UnsafeCell</span>;
<span class="kw">use</span> <span class="ident">std</span>::<span class="ident">ptr</span>::<span class="ident">NonNull</span>;

<span class="kw">use</span> <span class="kw">super</span>::<span class="ident">std</span>::<span class="ident">Core</span>;
<span class="kw">use</span> <span class="kw">crate</span>::<span class="ident">rngs</span>::<span class="ident">adapter</span>::<span class="ident">ReseedingRng</span>;
<span class="kw">use</span> <span class="kw">crate</span>::<span class="ident">rngs</span>::<span class="ident">OsRng</span>;
<span class="kw">use</span> <span class="kw">crate</span>::{<span class="ident">CryptoRng</span>, <span class="ident">Error</span>, <span class="ident">RngCore</span>, <span class="ident">SeedableRng</span>};

<span class="comment">// Rationale for using `UnsafeCell` in `ThreadRng`:</span>
<span class="comment">//</span>
<span class="comment">// Previously we used a `RefCell`, with an overhead of ~15%. There will only</span>
<span class="comment">// ever be one mutable reference to the interior of the `UnsafeCell`, because</span>
<span class="comment">// we only have such a reference inside `next_u32`, `next_u64`, etc. Within a</span>
<span class="comment">// single thread (which is the definition of `ThreadRng`), there will only ever</span>
<span class="comment">// be one of these methods active at a time.</span>
<span class="comment">//</span>
<span class="comment">// A possible scenario where there could be multiple mutable references is if</span>
<span class="comment">// `ThreadRng` is used inside `next_u32` and co. But the implementation is</span>
<span class="comment">// completely under our control. We just have to ensure none of them use</span>
<span class="comment">// `ThreadRng` internally, which is nonsensical anyway. We should also never run</span>
<span class="comment">// `ThreadRng` in destructors of its implementation, which is also nonsensical.</span>


<span class="comment">// Number of generated bytes after which to reseed `ThreadRng`.</span>
<span class="comment">// According to benchmarks, reseeding has a noticable impact with thresholds</span>
<span class="comment">// of 32 kB and less. We choose 64 kB to avoid significant overhead.</span>
<span class="kw">const</span> <span class="ident">THREAD_RNG_RESEED_THRESHOLD</span>: <span class="ident">u64</span> <span class="op">=</span> <span class="number">1024</span> <span class="op">*</span> <span class="number">64</span>;

<span class="doccomment">/// The type returned by [`thread_rng`], essentially just a reference to the</span>
<span class="doccomment">/// PRNG in thread-local memory.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// `ThreadRng` uses the same PRNG as [`StdRng`] for security and performance.</span>
<span class="doccomment">/// As hinted by the name, the generator is thread-local. `ThreadRng` is a</span>
<span class="doccomment">/// handle to this generator and thus supports `Copy`, but not `Send` or `Sync`.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// Unlike `StdRng`, `ThreadRng` uses the  [`ReseedingRng`] wrapper to reseed</span>
<span class="doccomment">/// the PRNG from fresh entropy every 64 kiB of random data.</span>
<span class="doccomment">/// [`OsRng`] is used to provide seed data.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// Note that the reseeding is done as an extra precaution against side-channel</span>
<span class="doccomment">/// attacks and mis-use (e.g. if somehow weak entropy were supplied initially).</span>
<span class="doccomment">/// The PRNG algorithms used are assumed to be secure.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// [`ReseedingRng`]: crate::rngs::adapter::ReseedingRng</span>
<span class="doccomment">/// [`StdRng`]: crate::rngs::StdRng</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Copy</span>, <span class="ident">Clone</span>, <span class="ident">Debug</span>)]</span>
<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">ThreadRng</span> {
    <span class="comment">// inner raw pointer implies type is neither Send nor Sync</span>
    <span class="ident">rng</span>: <span class="ident">NonNull</span><span class="op">&lt;</span><span class="ident">ReseedingRng</span><span class="op">&lt;</span><span class="ident">Core</span>, <span class="ident">OsRng</span><span class="op">&gt;</span><span class="op">&gt;</span>,
}

<span class="macro">thread_local</span><span class="macro">!</span>(
    <span class="kw">static</span> <span class="ident">THREAD_RNG_KEY</span>: <span class="ident">UnsafeCell</span><span class="op">&lt;</span><span class="ident">ReseedingRng</span><span class="op">&lt;</span><span class="ident">Core</span>, <span class="ident">OsRng</span><span class="op">&gt;</span><span class="op">&gt;</span> <span class="op">=</span> {
        <span class="kw">let</span> <span class="ident">r</span> <span class="op">=</span> <span class="ident">Core</span>::<span class="ident">from_rng</span>(<span class="ident">OsRng</span>).<span class="ident">unwrap_or_else</span>(<span class="op">|</span><span class="ident">err</span><span class="op">|</span>
                <span class="macro">panic</span><span class="macro">!</span>(<span class="string">&quot;could not initialize thread_rng: {}&quot;</span>, <span class="ident">err</span>));
        <span class="kw">let</span> <span class="ident">rng</span> <span class="op">=</span> <span class="ident">ReseedingRng</span>::<span class="ident">new</span>(<span class="ident">r</span>,
                                    <span class="ident">THREAD_RNG_RESEED_THRESHOLD</span>,
                                    <span class="ident">OsRng</span>);
        <span class="ident">UnsafeCell</span>::<span class="ident">new</span>(<span class="ident">rng</span>)
    }
);

<span class="doccomment">/// Retrieve the lazily-initialized thread-local random number generator,</span>
<span class="doccomment">/// seeded by the system. Intended to be used in method chaining style,</span>
<span class="doccomment">/// e.g. `thread_rng().gen::&lt;i32&gt;()`, or cached locally, e.g.</span>
<span class="doccomment">/// `let mut rng = thread_rng();`.  Invoked by the `Default` trait, making</span>
<span class="doccomment">/// `ThreadRng::default()` equivalent.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// For more information see [`ThreadRng`].</span>
<span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">thread_rng</span>() <span class="op">-</span><span class="op">&gt;</span> <span class="ident">ThreadRng</span> {
    <span class="kw">let</span> <span class="ident">raw</span> <span class="op">=</span> <span class="ident">THREAD_RNG_KEY</span>.<span class="ident">with</span>(<span class="op">|</span><span class="ident">t</span><span class="op">|</span> <span class="ident">t</span>.<span class="ident">get</span>());
    <span class="kw">let</span> <span class="ident">nn</span> <span class="op">=</span> <span class="ident">NonNull</span>::<span class="ident">new</span>(<span class="ident">raw</span>).<span class="ident">unwrap</span>();
    <span class="ident">ThreadRng</span> { <span class="ident">rng</span>: <span class="ident">nn</span> }
}

<span class="kw">impl</span> <span class="ident">Default</span> <span class="kw">for</span> <span class="ident">ThreadRng</span> {
    <span class="kw">fn</span> <span class="ident">default</span>() <span class="op">-</span><span class="op">&gt;</span> <span class="ident">ThreadRng</span> {
        <span class="kw">crate</span>::<span class="ident">prelude</span>::<span class="ident">thread_rng</span>()
    }
}

<span class="kw">impl</span> <span class="ident">RngCore</span> <span class="kw">for</span> <span class="ident">ThreadRng</span> {
    <span class="attribute">#[<span class="ident">inline</span>(<span class="ident">always</span>)]</span>
    <span class="kw">fn</span> <span class="ident">next_u32</span>(<span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="self">self</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="ident">u32</span> {
        <span class="kw">unsafe</span> { <span class="self">self</span>.<span class="ident">rng</span>.<span class="ident">as_mut</span>().<span class="ident">next_u32</span>() }
    }

    <span class="attribute">#[<span class="ident">inline</span>(<span class="ident">always</span>)]</span>
    <span class="kw">fn</span> <span class="ident">next_u64</span>(<span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="self">self</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="ident">u64</span> {
        <span class="kw">unsafe</span> { <span class="self">self</span>.<span class="ident">rng</span>.<span class="ident">as_mut</span>().<span class="ident">next_u64</span>() }
    }

    <span class="kw">fn</span> <span class="ident">fill_bytes</span>(<span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="self">self</span>, <span class="ident">dest</span>: <span class="kw-2">&amp;</span><span class="kw-2">mut</span> [<span class="ident">u8</span>]) {
        <span class="kw">unsafe</span> { <span class="self">self</span>.<span class="ident">rng</span>.<span class="ident">as_mut</span>().<span class="ident">fill_bytes</span>(<span class="ident">dest</span>) }
    }

    <span class="kw">fn</span> <span class="ident">try_fill_bytes</span>(<span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="self">self</span>, <span class="ident">dest</span>: <span class="kw-2">&amp;</span><span class="kw-2">mut</span> [<span class="ident">u8</span>]) <span class="op">-</span><span class="op">&gt;</span> <span class="prelude-ty">Result</span><span class="op">&lt;</span>(), <span class="ident">Error</span><span class="op">&gt;</span> {
        <span class="kw">unsafe</span> { <span class="self">self</span>.<span class="ident">rng</span>.<span class="ident">as_mut</span>().<span class="ident">try_fill_bytes</span>(<span class="ident">dest</span>) }
    }
}

<span class="kw">impl</span> <span class="ident">CryptoRng</span> <span class="kw">for</span> <span class="ident">ThreadRng</span> {}


<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">test</span>)]</span>
<span class="kw">mod</span> <span class="ident">test</span> {
    <span class="attribute">#[<span class="ident">test</span>]</span>
    <span class="kw">fn</span> <span class="ident">test_thread_rng</span>() {
        <span class="kw">use</span> <span class="kw">crate</span>::<span class="ident">Rng</span>;
        <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">r</span> <span class="op">=</span> <span class="kw">crate</span>::<span class="ident">thread_rng</span>();
        <span class="ident">r</span>.<span class="ident">gen</span>::<span class="op">&lt;</span><span class="ident">i32</span><span class="op">&gt;</span>();
        <span class="macro">assert_eq</span><span class="macro">!</span>(<span class="ident">r</span>.<span class="ident">gen_range</span>(<span class="number">0</span>, <span class="number">1</span>), <span class="number">0</span>);
    }
}
</pre></div>
</section><section id="search" class="content hidden"></section><section class="footer"></section><script>window.rootPath = "../../../";window.currentCrate = "rand";</script><script src="../../../main.js"></script><script src="../../../source-script.js"></script><script src="../../../source-files.js"></script><script defer src="../../../search-index.js"></script></body></html>